package controller;

import javax.enterprise.context.Conversation;
import javax.faces.context.FacesContext;
import javax.inject.*;

import model.ConversationBean;

@Named("Conversation")
public class ConversationController {

	@Inject
	private ConversationBean conversationBean;

	@Inject
	private Conversation conversation;

	public ConversationBean getConversationBean() {
		return conversationBean;
	}

	public Conversation getConversation() {
		return conversation;
	}

	/**
	 * 开始conversation
	 */
	public void beginConversation() {
		//仅当前页面未被post提交，且conversation是"瞬时"性时，才开始conversation
		if (!FacesContext.getCurrentInstance().isPostback()
				&& conversation.isTransient()) {
			conversation.begin();
		}
	}
	
	
	public String endConversation(){
		//如果Conversation不是“瞬时”的，则结束conversion，同时所有ConversationScoped的对象也会销毁
		if (!conversation.isTransient()) {
			conversation.end();
		}
		//然后返回第1页
		return "page1?faces-redirect=true";
	}

	/**
	 * 供Ajax调用的方法
	 */
	public void addCounter() {
		conversationBean.addCounter();

	}

	/**
	 * 转到第2页
	 */
	public String gotoPage2() {
		// 注：faces-redirect=true会自动把conversion的id通过url parameter传递到page2
		return "page2?faces-redirect=true";
	}

}
